/* ce fichier definit les messages reconnus par le pic de SYR
Communication entre le PC et le PIC se deroule de la maniere suivante :
- le PC envoie une commande au PICc ( voir protocole partie A )
-le PIC repond a cette commande.   ( voir protocole partie B )
en dehors de cela le pic n'evoit rien s'il n'a pas recu une commande au prealable.


---------------------------------
A ) MESSAGES RECUS PAR LE PIC :  |
---------------------------------
les messages envoyes au PIC sont formes de la maniere suivante :

START_FLAG    1 octet : la valeur est 0x55
SIZE          1 octet : la valeur >=2 et <8 correspond aux nombre d'octets 				suivant la SIZE
ID	      1 octet : valeur comprise entre 1 et 255, elle sera recopiee dans 				la reponse. La valeur 0 est reserve pour un ID inconnu.
COMMAND       1 octet : correspond a la commande passee au PIC
PARAMETERS    plusieurs octests : depend de la commande

1) cas de la commande ENGINE
----------------------------
START_FLAG    	0x55
SIZE          	7
ID	      	XX
COMMAND       	'E'
STATUS	  	bit 0: 	RM_Select : 0=le moteur droit n'est pas concerne par la 				commande, 1 =il est concerne.
 	  	bit 1: 	RM_Sens : 1=avance , 0=recule
		bit 2: 	RM_Overwrite : 1=cette commande annule la precedente,
			0=cette commande n'est executee que si les 2 moteurs 				sont a l'arret
		bit 3: 	Reserved
		bit 4: 	LM_Select : 0=le moteur dorit n'est pas concerne par la
			commande, 1=il est concerne.
		bit 5: 	LM_Sens : 1=avance , 0=recule
		bit 6: 	LM_Overwrite : 1=cette commande annule la precedente,
 			0=cette commande n'est executee que si les 2 moteurs
			sont a l'arret
		bit 7: 	Reserved
LM_SPEED	valeur entre 0 et 200
RM_SPEED	valeur entre 0 et 200
TIME_EXEC	valeur entre 1 et 255, 0 correspond a un stop
UNIT_EXEC	valeur ente 0 et 7, correspond a l'unite de TIME_EXEC,
		0= 1us,1=10us,2=100us,3=1ms,4=10ms,5=100ms,6=1s,7=AVE.
note : si UNIT_EXEC = 7 il s'agit d'une commande Ad VitamEternam,
       sinon, si TIME_EXEC = 0 , on arrete les machines.

gestion des cas d'erreur sur les parametres :
	- si on tente de changer un des moteurs de sens alors que les moteurs tournent => arret des 2 moteurs et renvoi d'un flag Bad parameter
	- si on tente de mettre une valeur de vitesse superieure a 200 => la vitesse sera placee a 200 et renvoi d'un flag Bad parameter
	- si on tente de changer une commande sur un des moteur sans Overwrite alors qu'au moins un des moteurs est en cours de fonctionnement, la commande n'est pas prise en compte pour le moteur concerne et renvoi d'un flag Bad parameter.
	- si le temps n'est pas correct ( UNIT_EXEC > 7 ) on stoppe les machines et leve un flag bat parameter

2) cas de la commande STILL_ALIVE
---------------------------------
START_FLAG    	0x55
SIZE          	2
ID	      	XX
COMMAND       	'S'

3) Cas d'un GET_SPEED ( pour obtenir la vitesse actuelle des moteurs)
----------------------
START_FLAG    	0x55
SIZE          	2
ID	      	XX
COMMAND       	'G'

4) Cas d'un GET_EXEC_TIME ( pour obtenir le temps restant avant la fin de la commande )
--------------------------
START_FLAG    	0x55
SIZE          	2
ID	      	XX
COMMAND       	'g'


5) Cas d'un SET_STILL_ALIVE
---------------------------
START_FLAG    	0x55
SIZE          	4
ID	      	XX
COMMAND       	's'
TIME_EXEC	valeur entre 1 et 255, 0 correspond a un temps infini ( pas de
		stillAlive)
UNIT_EXEC	valeur ente 0 et 6, correspond a l'unite de TIME_EXEC,
		0= 1us,1=10us,2=100us,3=1ms,4=10ms,5=100ms,6=1s,7=AVE(noSE).
pour deselectionner le StillAlive : TIME_EXEC=0 ou UNIT_EXEC=7 .



----------------------------------
B ) MESSAGES ENVOYES PAR LE PIC : |
----------------------------------
les messages envoyes par le PIC sont formes de la maniere suivante :

START_FLAG    1 octet : la valeur est 0x55
SIZE          1 octet : la valeur >=2 correspond aux nombre d'octets 				suivant la SIZE
ID	      1 octet : correspond a la recopie de l'ID dans le message envoye. 				si cet ID est inconnu (cas dans les messages errones ) 				La valeur 0 sera inscrite.
STATUS        1 octet : indique l'etat du systeme et de la derniere commande
			voir plus bas
PARAMETERS    0 ou plusieurs octets : depend de la commande

------
STATUS
------
bit 0 :BAD_PARAMETERS : un ou plusieurs parametres dans la derniere commande sont errones
bit 1 :UNKNOWN_COMMAND : la derniere commande est inconnue
bit 2 :BAD_SIZE : taille en dehors des limites ( dans ce cas le PIC considere
	que la size est 0 et donc, essaye tout de retrouver un START_FLAG des
	le prochain octet recu)
bit 3 :BAD_START : l'octet START est errone , il ya probablement eu une 		desynchronisation.
bit 4 : MR_ON : le moteur droit tourne au moment de l'envoi de la reponse
bit 5 : ML_ON : le moteur gauche tourne au moment de l'envoi de la reponse
bit 6 : STILL_ALIVE_TIMEOUT : a 1 si on a pas eu de stillAlive ou de nouvelle commande depuis un certain temps .
bit 7 : BUFFER_OVERFLOW : le buffer de commandes du PIC a deborde.

1) Reponse a la Commande ENGINE, STILL_ALIVE,SET_STILL_ALIVE:

START_FLAG    0x55
SIZE          2
ID	      XX
STATUS        YY

2) Reponse a la commande GET_SPEED

START_FLAG    0x55
SIZE          4
ID	      XX
STATUS        YY
LM_SPEED      vitesse entre 0 et 200
RM_SPEED      vitesse entre 0 et 200

2) Reponse a la commande GET_EXEC_TIME

START_FLAG    0x55
SIZE          4
ID	      XX
STATUS        YY
TIME_EXEC	valeur entre 0 et 255, 0 correspond a une commande terminee,
UNIT_EXEC	valeur ente 0 et 6, correspond a l'unite de TIME_EXEC,
		0= 1us,1=10us,2=100us,3=1ms,4=10ms,5=100ms,6=1s,7=AVE.

note :  en cas de STILL ALIVE, UNIT_EXEC=7  TIME_EXEC est quelconque

*/
// nombre maximum de parametres : 16 changer ici si cette affirmation devient fausse
#define MAX_PARAMETERS 16


//////////////////////////
// messages de controle EMIS PAR  //
//////////////////////////

#define START_FLAG  0x55
#define ENGINE 	    'E'
#define STILL_ALIVE 'S'
#define SET_STILL_ALIVE 's'
#define GET_SPEED   'G'
#define GET_EXEC_TIME 'g'

//////////////////////////
// signaux pour le sens //
//////////////////////////

#define SENS_AVANCE 1
#define SENS_RECULE 0
//////////////
// STATUS   //
//////////////

#define S_BAD_PARAMETER		0x01
#define S_UNKNOWN_COMMAND	0x02
#define S_BAD_SIZE		0x04
#define S_BAD_START		0x08
#define S_RM_ON			0x10
#define S_LM_ON			0x20
#define S_STILL_ALIVE_TIMEOUT	0x40
#define S_BUFFER_OVERFLOW	0x80

#define S_RM_SELECT		0x01
#define S_RM_SENS			0x02
#define S_RM_OVERWRITE	0x04
#define S_LM_SELECT 		0x10
#define S_LM_SENS			0x20
#define S_LM_OVERWRITE	0x40
///////////////
// TIME UNITS//
///////////////
#define _USEC 		0
#define _10USEC 	1
#define _100USEC 	2
#define _MSEC 		3
#define _10MSEC		4
#define _100MSEC	5
#define _SEC		6
#define _AVE		7
